#
# $Id: psql_utils.rb 8 2007-12-06 10:36:47Z isr $
#
begin
	require 'postgres'
rescue LoadError
	require 'rubygems'
	require 'postgres'
end


module PsqlUtils
	module_function

	# PostgreSQL ФΥСʸ
	def query_version
		'SELECT version();'
	end


	# PostgreSQL Ф 7.4.x ʹߤǡ
	# СֹΤߤȤϤȤ
	def query_version_number
		"SELECT setting FROM pg_settings WHERE name = 'server_version';"
	end


	def query_list_dbs
		<<_EOS_
SELECT d.datname as "Name",
     r.rolname as "Owner",
     pg_catalog.pg_encoding_to_char(d.encoding) as "Encoding"
FROM pg_catalog.pg_database d
JOIN pg_catalog.pg_roles r ON d.datdba = r.oid
ORDER BY 1;
_EOS_
	end


	def query_list_tables
		<<_EOS_
SELECT n.nspname as "Schema",
       c.relname as "Name",
       CASE c.relkind
       WHEN 'r' THEN 'table' WHEN 'v' THEN 'view' 
       WHEN 'i' THEN 'index' WHEN 'S' THEN 'sequence' 
       WHEN 's' THEN 'special' 
       END as "Type",
       r.rolname as "Owner"
FROM pg_catalog.pg_class c
     JOIN pg_catalog.pg_roles r ON r.oid = c.relowner
     LEFT JOIN pg_catalog.pg_namespace n ON n.oid = c.relnamespace
WHERE c.relkind IN ('r','')
      AND n.nspname NOT IN ('pg_catalog', 'pg_toast')
      AND pg_catalog.pg_table_is_visible(c.oid)
ORDER BY 1,2;
_EOS_
	end


	def query_list_users
		<<_EOS_
SELECT r.rolname AS "Role name",
  CASE WHEN r.rolsuper THEN 'yes' ELSE 'no' END AS "Superuser",
  CASE WHEN r.rolcreaterole THEN 'yes' ELSE 'no' END AS "Create role",
  CASE WHEN r.rolcreatedb THEN 'yes' ELSE 'no' END AS "Create DB",
  CASE WHEN r.rolconnlimit < 0 THEN CAST('no limit' AS pg_catalog.text)
       ELSE CAST(r.rolconnlimit AS pg_catalog.text)
  END AS "Connections",
  ARRAY(SELECT b.rolname 
             FROM pg_catalog.pg_auth_members m 
             JOIN pg_catalog.pg_roles b ON (m.roleid = b.oid)
             WHERE m.member = r.oid)
       AS "Member of"
FROM pg_catalog.pg_roles r
ORDER BY 1;
_EOS_
	end
end
